﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using System.IO.Packaging;
using System.Windows.Xps;
using System.Windows.Xps.Packaging;
using Microsoft.Win32;
using DlhSoft.Windows.Controls;
using System.Printing;

namespace GanttChartTaskListViewExportXpsDocumentSample
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }

        private void ExportMenuItem_Click(object sender, RoutedEventArgs e)
        {
            // Select an XPS document file to export to.
            SaveFileDialog saveFileDialog = new SaveFileDialog { Title = "Specify the XPS document file to export to", Filter = "XPS document files|*.xps" };
            if (saveFileDialog.ShowDialog() != true)
                return;

            // Get the export size and drawing visual.
            Size size = GanttChartTaskListView.GetExportSize();
            DrawingVisual drawingVisual = GanttChartTaskListView.GetExportDrawingVisual();

            // Initialize the printing ticket.
            PrintTicket printTicket = new PrintTicket();
            printTicket.PageMediaSize = new PageMediaSize(size.Width, size.Height);

            using (Stream stream = saveFileDialog.OpenFile())
            {
                // Encode content to XPS format.
                using (Package package = Package.Open(stream, FileMode.Create))
                {
                    using (XpsDocument document = new XpsDocument(package))
                    {
                        XpsDocumentWriter writer = XpsDocument.CreateXpsDocumentWriter(document);
                        writer.Write(drawingVisual, printTicket);
                    }
                }
            }
        }
    }
}
